=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 ADD_EXECUTABLE( fmis FilteredMIS.cpp )
 ADD_EXECUTABLE( mcl MCL.cpp )
 ADD_EXECUTABLE( betwcent BetwCent.cpp )
-
+ADD_EXECUTABLE(lacc CC.cpp)
 
 TARGET_LINK_LIBRARIES( tdbfs CombBLAS)
 TARGET_LINK_LIBRARIES( dobfs CombBLAS)
@@ -15,6 +15,7 @@
 TARGET_LINK_LIBRARIES( fmis CombBLAS)
 TARGET_LINK_LIBRARIES( mcl CombBLAS)
 TARGET_LINK_LIBRARIES( betwcent CombBLAS)
+TARGET_LINK_LIBRARIES( lacc CombBLAS)
 
 ADD_TEST(NAME BetwCent_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:betwcent> ../TESTDATA/SCALE16BTW-TRANSBOOL/ 10 96 )
 ADD_TEST(NAME TopDownBFS_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:tdbfs> Force 17 FastGen)
