=== ReleaseTests/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,13 @@
 ADD_EXECUTABLE( IndexingTiming IndexingTiming.cpp )
 ADD_EXECUTABLE( FindSparse FindSparse.cpp )
 ADD_EXECUTABLE( ParIOTest ParIOTest.cpp )
+ADD_EXECUTABLE( GenWrMat GenWriteMatrix.cpp )
+ADD_EXECUTABLE( BlockedSpGEMM BlockedSpGEMM.cpp )
+ADD_EXECUTABLE( SpGEMM3DTest SpGEMM3DTest.cpp )
+ADD_EXECUTABLE( HashSpGEMMTest HashSpGEMMTest.cpp )
+ADD_EXECUTABLE( InducedSubgraphsTest InducedSubgraphsTest.cpp )
+ADD_EXECUTABLE( PruneColumn PruneColumn.cpp )
+ADD_EXECUTABLE( KTipsTest KTipsTest.cpp )
 
 TARGET_LINK_LIBRARIES( MultTiming CombBLAS)
 TARGET_LINK_LIBRARIES( MultTest CombBLAS)
@@ -23,9 +30,18 @@
 TARGET_LINK_LIBRARIES( IndexingTiming CombBLAS)
 TARGET_LINK_LIBRARIES( FindSparse CombBLAS)
 TARGET_LINK_LIBRARIES( ParIOTest CombBLAS)
+TARGET_LINK_LIBRARIES( GenWrMat CombBLAS)
+TARGET_LINK_LIBRARIES( BlockedSpGEMM CombBLAS)
+TARGET_LINK_LIBRARIES( SpGEMM3DTest CombBLAS)
+TARGET_LINK_LIBRARIES( HashSpGEMMTest CombBLAS)
+TARGET_LINK_LIBRARIES( InducedSubgraphsTest CombBLAS)
+TARGET_LINK_LIBRARIES( PruneColumn CombBLAS)
+TARGET_LINK_LIBRARIES( KTipsTest CombBLAS)
 
-
+ADD_TEST(NAME GenMMWrite_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:GenWrMat> 20 16 1 scale20_ef16_symmetric.mtx)
 ADD_TEST(NAME Multiplication_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:MultTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx ../TESTDATA/x_65536_halfdense.txt ../TESTDATA/y_65536_halfdense.txt )
+ADD_TEST(NAME SpGEMM3D_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 16 $<TARGET_FILE:SpGEMM3DTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx )
+ADD_TEST(NAME HashSpGEMMTest COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 1 $<TARGET_FILE:HashSpGEMMTest> ../TESTDATA/rmat_scale16_A.mtx ../TESTDATA/rmat_scale16_B.mtx ../TESTDATA/rmat_scale16_productAB.mtx )
 ADD_TEST(NAME Reduction_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:ReduceTest> ../TESTDATA/sprand10000 ../TESTDATA/sprand10000_sumcols ../TESTDATA/sprand10000_sumrows)
 ADD_TEST(NAME Iterator_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:IteratorTest> ../TESTDATA sprand10000)
 ADD_TEST(NAME Transpose_Test COMMAND ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 $<TARGET_FILE:TransposeTest> ../TESTDATA betwinput_scale16 betwinput_transposed_scale16)
