=== debian/changelog ===
combblas (2.0.0-7) unstable; urgency=medium

  * replace debian patch cmake_multiarch.patch with cmake4_PR31.diff
    applying upstream PR#31 to update cmake definitions for cmake 4.
    Closes: #1112804.
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Sun, 28 Sep 2025 01:31:35 +0200

combblas (2.0.0-6) unstable; urgency=medium

  * Team upload.
  * Drop quotes around the value of PRTE_MCA_rmaps_default_mapping_policy in
    debian/rules, since debian/rules is a Makefile and quotes are interpreted
    literally in Makefile's.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Thu, 31 Oct 2024 10:30:14 +0000

combblas (2.0.0-5) unstable; urgency=medium

  * Team upload.
  * OpenMPI 5.0 changed the name and the value of the environment variable to
    allow oversubscription from
       export OMPI_MCA_rmaps_base_oversubscribe=1
    to
       export PRTE_MCA_rmaps_default_mapping_policy=":oversubscribe"
  * OpenMPI 5.0 changed the name of the environment variable to set the SSH
    agent from
       export OMPI_MCA_plm_rsh_agent=/bin/false
    to
       export PRTE_MCA_plm_ssh_agent=/bin/false
  * Set lower bound >= 1.17 to Build-Depends: mpi-default-dev because the
    two environment variables above, PRTE_MCA_rmaps_default_mapping_policy
    and PRTE_MCA_plm_ssh_agent, are set at build time in debian/rules

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 27 Oct 2024 15:43:16 +0000

combblas (2.0.0-4) unstable; urgency=medium

  * openmpi 5 dropped libmpi_cxx.so. Rebuild.
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Sat, 19 Oct 2024 14:56:14 +0200

combblas (2.0.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061882

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:11:06 +0000

combblas (2.0.0-3) unstable; urgency=medium

  * reinstate and update debian/patches/AWPM_library_38dd27e.patch.
    ThreadBuffLenForBinning is not yet set inline.
    GlobalMT not yet patched upstream in BipartiteMatchings headers
    BPMaximalMatching.h and BPMaximumMatching.h

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Aug 2023 02:57:33 +0200

combblas (2.0.0-2) unstable; urgency=medium

  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Aug 2023 13:04:07 +0200

combblas (2.0.0-1exp2) experimental; urgency=medium

  * use arch-indep Build-Depends-Indep: doxygen, graphviz
    for doc build
  * debian patches mpi_comm_eb4811a.diff and mpi_comm_ecf9621.diff
    apply upstream commits eb4811a and ecf9621 to fix MPI_COMM
    handling. See also SuperLU-Dist Issue #124.
  * debian/tests: run tests from both ReleaseTests and Applications
    - Applications_CMakeLists.txt.patch provides patch to enable
      Applications build against installed CombBLAS.
  * set OMPI_MCA_rmaps_base_oversubscribe=1 at build time to allow
    build-time tests to run when 4 CPUs are not available

 -- Drew Parsons <dparsons@debian.org>  Sat, 08 Jul 2023 17:31:56 +0200

combblas (2.0.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - applies debian patch AWPM_library_38dd27e.patch
  * update debian/watch and copyright to new upstream repo
    https://github.com/PASSIONLab/CombBLAS
  * debian patch update_version_PR18.patch updates project version
    (see upstream PR#18)
    - update to ABI 2.0.0
  * debian/rules: remove redundant MacOS ._CombBLAS.h fix
  * update BipartiteMatchings source location (headers), now taken from
    Applications subdirectory.
  * remove doc dir after dh_clean (generated by doxygen)
  * update debian/tests/ReleaseTests_CMakeLists.txt.patch to add MPI
    links and link GenWrMat with GraphGenlib

 -- Drew Parsons <dparsons@debian.org>  Fri, 07 Jul 2023 13:31:43 +0200
