=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  cmake (>= 3.3),
- doxygen,
- graphviz,
- mpi-default-dev
-Standards-Version: 4.6.0
+ mpi-default-dev (>= 1.17)
+Build-Depends-Indep: doxygen,
+ graphviz
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://people.eecs.berkeley.edu/~aydin/CombBLAS/html/index.html
 Vcs-Browser: https://salsa.debian.org/science-team/combblas
@@ -17,7 +17,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libcombblas1.16.0 (= ${binary:Version}), ${misc:Depends}
+Depends: libcombblas2.0.0t64 (= ${binary:Version}), ${misc:Depends}
 Suggests: libcombblas-docs
 Description: an extensible parallel graph library for graph analytics
  The Combinatorial BLAS (CombBLAS) is an extensible distributed-memory
@@ -36,7 +36,10 @@
  This package provides development files for building client
  applications against combblas.
 
-Package: libcombblas1.16.0
+Package: libcombblas2.0.0t64
+Provides: ${t64:Provides}
+Replaces: libcombblas2.0.0
+Breaks: libcombblas2.0.0 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
