=== debian/rules ===
--- 
+++ 
@@ -19,12 +19,15 @@
 LIBDIR = $(CURDIR)/$(BUILDDIR)
 
 # Allow test programs that uses OpenMPI to run
-export OMPI_MCA_plm_rsh_agent=/bin/false
+export PRTE_MCA_plm_ssh_agent=/bin/false
+export PRTE_MCA_rmaps_default_mapping_policy=:oversubscribe
 
 
 %:
 	dh $@
 
+execute_after_dh_clean:
+	rm -rf doc
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -41,11 +44,6 @@
 override_dh_auto_test-indep:
 	# no tests for docs
 
-override_dh_auto_install:
-	dh_auto_install
-	# MacOS auxiliary file, should never have been installed
-	rm -f debian/tmp/usr/include/CombBLAS/._CombBLAS.h
-
 override_dh_installchangelogs:
 	dh_installchangelogs release-notes.html
