=== debian/tests/control ===
Tests: test-combblas
Depends: @, @builddeps@
Restrictions: allow-stderr
